package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DetailTriaseService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.DetailTriaseVO;


/******************
 * @author Shakato
 ******************/
@RestController
@RequestMapping("/detail-triase")
@JsonIgnoreProperties(ignoreUnknown = true) 
public class DetailTriaseController extends LocaleController<DetailTriaseVO> implements IBaseRestController<DetailTriaseVO> {

	@Autowired
	private DetailTriaseService detailTriaseService;
	

	private static final Logger LOGGER 	= LoggerFactory.getLogger(DetailTriaseController.class);


	@RequestMapping(value = "/save-detail-triase", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<String> saveDetailTriase(@Valid @RequestBody DetailTriaseVO vo,HttpServletRequest request) {
		try {
			DetailTriaseVO result = detailTriaseService.add(vo);
			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			RestUtil.getJsonHttptatus(HttpStatus.CREATED);
			return RestUtil.getJsonResponse("Status Sukses", HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Status Keluarga", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Status Keluarga", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}



	@Override
	public ResponseEntity<DetailTriaseVO> getVO(Integer id) {
		return null;
	}


	@Override
	public ResponseEntity<String> addVO(DetailTriaseVO vo) {
		return null;
	}


	@Override
	public ResponseEntity<String> editVO(DetailTriaseVO vo) {
		return null;
	}


	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}


	@Override
	public ResponseEntity<List<DetailTriaseVO>> getAllVO() {
		return null;
	}



	@Override
	public ResponseEntity<Collection<DetailTriaseVO>> getAllVOWithQueryString(HttpServletRequest request, Integer page,
			Integer limit, String sort, String dir) {
		return null;
	}



	


	
}
